function class(base)
    local cls = {}
    cls.__index = cls
    return setmetatable(cls, {__index = base, __call = function (c, ...)
        local instance = setmetatable({}, cls)
        if cls.init then
            cls.init(instance, ...)
        end
        return instance
    end})
end

